import { PropsWithChildren, ReactElement } from 'react';

export type Range = [start: number, end: number];
export type RenderFn = (props: PropsWithChildren) => ReactElement;
export type Decor = {
    /**
     * Range to apply decoration. Invalid part of the range will be ignored.
     */
    range: Range;
    render?: RenderFn;
};
export declare function match(s: string, part: string | RegExp, render?: RenderFn): Decor[];
export declare function split(text: string, decors: Decor[] | undefined): Seg[];
export type Seg = {
    range: Range;
    renders: RenderFn[];
};
export declare function overlap(p: Seg, decor: Decor): Seg[];
